/*******************************************************************************
 * Copyright (c) 2004, 2005 IBM Corporation and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors:
 *     IBM Corporation - initial API and implementation
 *******************************************************************************/

package org.eclipse.wtp.releng.tools.component.java;

import org.eclipse.jdt.core.dom.ASTVisitor;
import org.eclipse.jdt.core.dom.PackageDeclaration;
import org.eclipse.jdt.core.dom.TypeDeclaration;
import org.eclipse.wtp.releng.tools.component.model.ComponentXML;
import org.eclipse.wtp.releng.tools.component.model.Package;

public class Java2APIVisitor extends ASTVisitor
{
  private ComponentXML compXML;
  private String packageName;

  public Java2APIVisitor(ComponentXML compXML)
  {
    super(false);
    this.compXML = compXML;
    this.packageName = null;
  }

  public boolean visit(PackageDeclaration node)
  {
    packageName = node.getName().getFullyQualifiedName();
    return true;
  }

  public boolean visit(TypeDeclaration node)
  {
    if (packageName != null)
    {
      Package pkg = compXML.getPackage(packageName);
      if (pkg == null)
      {
        pkg = new Package();
        pkg.setName(packageName);
        pkg.setApi(Boolean.TRUE);
        compXML.addPackage(pkg);
      }
    }
    return false;
  }
}